﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using StudentsBusiness;

namespace StudentManagementStudio
{
    public partial class NewStudent : Form
    {
        public NewStudent()
        {
            InitializeComponent();
        }

        private void cancelButton_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void saveButton_Click(object sender, EventArgs e)
        {
            //if validation was ok
            if (validate())
            {
                //create new object and save to the db
                saveToDb();
                this.Close();            
            }
        }

        private void saveToDb()
        {
            StudentMapper mapper = new StudentMapper();
            Student newStudent = new Student();

            newStudent.StudentName = studentNameTextBox.Text;
            if (descriptionTextBox.Text != string.Empty)
            {
                newStudent.StudentDescriptionText = descriptionTextBox.Text;            
            }
            newStudent.Class1 = class1TextBox.Text;
            if (class2TextBox.Text != string.Empty)
            {
                newStudent.Class2 = class2TextBox.Text;            
            }
            if (class3TextBox.Text != string.Empty)
            {
                newStudent.Class3 = class3TextBox.Text;
            }
            if (class4TextBox.Text != string.Empty)
            {
                newStudent.Class4 = class4TextBox.Text;
            }
            if (class5TextBox.Text != string.Empty)
            {
                newStudent.Class5 = class5TextBox.Text;
            }
            if (studentImageTextBox.Text != string.Empty)
            {
                newStudent.StudentImage = studentImageTextBox.Text;
            }
            newStudent.Status = statusTextBox.Text;
            newStudent.EnteredDate = dateTimePicker.Value;
            newStudent.Ranking = int.Parse(rankingMaskedTextBox.Text);
            
            mapper.insertStudent(newStudent);
        }

        private bool validate()
        {
            //check for problems
            if (studentNameTextBox.Text == string.Empty)
            {
                MessageBox.Show("Student name is required.");
                return false;
            }
            if (class1TextBox.Text == string.Empty)
            {
                MessageBox.Show("Class 1 is required.");
                return false;
            }
            if (statusTextBox.Text == string.Empty)
            {
                MessageBox.Show("Status is required.");
                return false;
            }
            //dateTimePicker doesn't seem to be emptyable
            if (rankingMaskedTextBox.Text == string.Empty)
            {
                MessageBox.Show("Ranking is required.");
                return false;
            }
            else 
            {
                if (int.Parse(rankingMaskedTextBox.Text) < 1)
                {
                    MessageBox.Show("Student must rank 1st or less (2nd, 3rd, 4th, etc..).");
                    return false;
                }            
            }
            return true;        
        }

        private void findFileButton_Click(object sender, EventArgs e)
        {
            DialogResult result = openFileDialog.ShowDialog();
	        if (result == DialogResult.OK) // Test result.
	        {
                studentImageTextBox.Text = openFileDialog.SafeFileName;
	        }
        }

    }
}
